*CMZ :  2.01/01 19/05/95  13.52.14  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE CH78TH (IARR, NARR)

************************************************************************
*
* Description: copy character string C78 into integer (real) array IARR
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   IARR   out    integer or real array (e.g. in the Zebra working space)
*                 The appropriate Zebra format is H.
*   NARR   in     length of IARR
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      INTEGER IARR, NARR, N, NCH
      DIMENSION IARR(NARR)

#include "arte/Arte.ff"

      NCH = MIN (N78MAX, 4 * NARR)
      DO 10 N = (NCH + 7) / 4, NARR
 10   IARR(N) = HBLANKSP
      CALL UCTOH (C78, IARR, 4, NCH)

      END

************************************************************************
* End of CH78TH
************************************************************************
