*-- Author :    Hartwig Albrecht   05/03/95

      SUBROUTINE IOCLOS (LUN)

************************************************************************
*
* Description: close file LUN or concatenated file
*
* Called from: anywhere
*
* External references: IFCLOS
*
* Argument in/out description
*  LUN     in     logical unit number
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"

      INTEGER I, L, LUN, CHIND1
      CHARACTER CMESS*120, CHO*8, CN*120, CSTR*80 

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      L = IMEIO_CURRENT(LUN)

      CMESS = 'close'
      CALL CHHTOC (IQ(HQMEIO_STREAM(1,LUN)), CSTR)
      CALL CHAPBC (CMESS, CSTR)
      CALL CHAPBC (CMESS, 'on')
      CALL CHAPBI (CMESS, LUN)
      CALL CHAPPC (CMESS, ':')
      CALL CHHTOC (IQ(HQMEIO_NAME(1,L)), CN)
      CALL CHAPBC (CMESS, CN)
      IF(CSTR(1:4) .EQ. 'READ') THEN
         CALL MESELP (CMESS, 'P')
      ELSE 
         CALL MEWARN (CMESS)
      ENDIF

      IQ(IQMEIO_TABLE(LUN)) = 0

      IF (IMEIO_FLAG(L) .LE. 0)  CALL MEERRC (9478256,
     +     'IOCLOSE: file has never been declared')

      IF (IMEIO_FLAG(L) .EQ. 1)  THEN
        IQ(IQMEIO_FLAG(L)) = 4

      ELSE
        CALL IFCLOS (LUN, IMEIO_IOSTAT(L))
        IQ(IQMEIO_FLAG(L)) = 5
        IF (IMEIO_IOSTAT(L) .NE. 0)  IQ(IQMEIO_FLAG(L)) = 4
        IF (IMEIO_PACK(L) .EQ. 1)  THEN
          CALL CHHTOC (IQ(HQMEIO_ZOPTION(1,L)), CHO)
          IF (LUN .EQ. LHIST)  THEN
            CALL HROUT (0, I, 'T')
            CALL HREND ('ARTE')
          ELSE IF (CHIND1 (CHO, 'O') .NE. 0)  THEN
            CALL FZENDO (LUN, 'QT')
          ELSE IF (CHIND1 (CHO, 'I') .NE. 0)  THEN
            CALL FZENDI (LUN, 'QT')
          END IF
        END IF
      END IF

 90   END

************************************************************************
* End of IOCLOS
************************************************************************
