      INTEGER FUNCTION WORDS(STR)

************************************************************************
*
* CERN PROGLIB# M433    WORDS           .VERSION KERNBIT  1.07  910903
* Author: M.Marquina 91/03/03
*
*-    Return number of words in string STR
*
************************************************************************
*
* Routine has been taken from CERN Library
*   (M433: Utility Package for Character Manipulation).
*
* Bugs fixed in Feb-May 1997 by A.Lanyov.
*   (Changes are marked by " ! AL" sign in the program text.)
*
************************************************************************

      CHARACTER*(*) STR

c#include "m433cs.inc"
      COMMON/M433CS/ICHSEP,CHSEP
      CHARACTER*1 CHSEP
C
      IF(ICHSEP.NE.1) THEN
        ICHSEP=1
        CHSEP=' '
      ENDIF


      LSTR=LENOCC(STR)
      WORDS=0
      if (lstr.le.0) return                             ! AL, May 1997
C*>   Strip leading characters
      I0=1
      DO WHILE(STR(I0:I0).EQ.CHSEP.AND.I0.LT.LSTR)
        I0=I0+1
      ENDDO
      if(i0.eq.lstr .and. str(i0:i0).ne.chsep) words=1  ! AL, Feb 1997
      IF(I0.EQ.LSTR) RETURN
      JW=1
      DO 10 N=I0,LSTR
        IF(STR(N:N).NE.CHSEP)            GOTO 10
        IF(STR(N-1:N-1).NE.CHSEP) JW=JW+1
 10   CONTINUE
      WORDS=JW
      RETURN
      END
