//                              -*- Mode: C++ -*-
//: EFCompareHitCells.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 26/5/97
// Last Update ........
//

#include"care/EFCompareHitCells.hh"


// Compare the energy of two Deposit structures and return true if
// the first energy is bigger than the second. 
bool EFCompareHitCells::operator () ( 
	       const int p1,  
	       const int p2){
  return ArtePointer<HITC>(p1)->q > ArtePointer<HITC>(p2)->q;
}
