*-- Author :    Mauro Villa   12/08/97


      subroutine precbo()

*     **** print ecbo information
      implicit none
      integer id1, id2, i, j, num, ecbo, echs, echf, line, lev
      character*3 cls(8)

#include "arte/Arte.fi"
#include "auto/ECBO.fi"
#include "auto/ECHS.fi"
#include "auto/ECHF.fi"
#include "arte/Arte.ff"
#include "auto/ECBO.ff"
#include "auto/ECHS.ff"
#include "auto/ECHF.ff"

*     **** parameters
      call kugeti(id1)
      call kugeti(id2)
      call kugeti(lev)

*     **** fixup
      if (id1.eq.0) then
         id1 = 1
         if (id2.eq.0) id2 = necbo()
      else
         if (id2.eq.0) id2 = id1
      endif
	
*     **** loop over range
      id1 = max(id1,1)
      id2 = min(id2,necbo())

      line = 0
        
      if(JECBO.NE.0) THEN
    
      do 10 ecbo=id1,id2
*        **** loop over associated mcals
         if (mod(line,20).eq.0) then
*           **** print headline
            print '(a6,a8,3x,a8,a5,a10)',
     +                 'ecbo','fed ID ',' status ',' num ',' active ch'
         endif
	 num = 0
	 do i=1,32
	   if( iecbo_chan(i,ecbo).ge.1) num=num+1
	 end do
         print '(i6,z8,3x,z8,3x,i4,1x,i5)',
     +              ecbo,iecbo_fdid(ecbo),iecbo_stat(ecbo),
     +              iecbo_numb(ecbo),num
	 if( lev.gt.0) then
*          loop over linked channels
	   do j=1,4
	     do i=1,8
	       echf = iecbo_chan((j-1)*8+i,ecbo)
	       echs = echf
               if( echf.gt.0) then
		  if( iechs_fdid(echs).eq.iecbo_fdid(ecbo).and.
     .                iechs_chan(echs).eq.(j-1)*8+i-1.and.
     .                iechs_ecbo(echs).eq.ecbo) then
                    cls(i) = '   '
	          else
                    cls(i) = 'BAD'
                  endif
	       else
		  cls(i) = '   '
	       endif	
             end do
             print '(13x,8(i5,a3))',
     +                                   (iecbo_chan(i+(j-1)*8,ecbo),
     +                                   cls(i),i=1,8)
	   end do
	 endif
         line = line + 1
 10   continue	
      END IF	
 20   print *,' total number of ecbo rows:', necbo()


      end

