#ifndef _DBARTEBRIDGE_H_

#   include <sys/types.h>
#   include "mizzi/table.h"

#   define DB_MAX_NAME_SIZE		80
#   define DB_MAX_TABLE_NAME_SIZE	16
#   define TABLE_DESC_LEN               5000


#   define _DBARTEBRIDGE_H_


void DbOpen (int  lun, char *fname, int rwflag, int *ierr);

void DbClose(int  lun, int *ierr);

void DbWriteHeader(int  lun, int *Mlink, int  major, int  minor, int *ierr);
void DbWriteTable (int  lun, int *Mlink, int  major, int  minor, int *ierr);
void DbWriteAll   (int  lun,             int  major, int  minor, int *ierr);

void DbReadHeader(int  lun, int *Mlink, int  maj, int  min, char *opt,int *ierr);
void DbReadTable (int  lun, int *Mlink, int  maj, int  min, char *opt,int *ierr);
void DbReadAll   (int  lun,             int  maj, int  min, char *opt,int *ierr);

void dbstop_(void);
void dbinit_(void);

void DbListFile(char *);

#endif




