#ifndef _RTRA_HH_
#define _RTRA_HH_
struct RTRA_RREL;
struct RTRA_HITB;
struct RTRA_HITC;
struct RTRA_RPNT;
struct RTRA_MTRA;
struct RTRA_RSEG;
struct RTRA_RCCL;
struct RTRA {
   float zf;
   float xf;
   float yf;
   float txf;
   float tyf;
   float pf;
   float cvf[15];
   int hsi;
   int hin;
   int hou;
   int hri;
   int hca;
   int htr;
   int hmu;
   int fit;
   float chi;
   float lre;
   float lrmu;
   float lrpi;
   float lrk;
   float lrp;
   int flr;
   ArtePointer<TOPP> topp;
   float lte;
   float lth;
   int flt;
   float lee;
   float lemi;
   float leh;
   int fle;
   float lmmu;
   float lmh;
   int flm;
   ArtePointer<RVER> ever;
   ArteRelationPointer<RTRA_RREL> rrel;
   ArteRelationPointer<RTRA_HITB> hitb;
   ArteRelationPointer<RTRA_HITC> hitc;
   ArteRelationPointer<RTRA_RPNT> rpnt;
   ArteRelationPointer<RTRA_MTRA> mtra;
   ArteRelationPointer<RTRA_RSEG> rseg;
   ArteRelationPointer<RTRA_RCCL> rccl;
};
#include "auto/TOPP.hh"
#include "auto/RTTO.hh"
#include "auto/RVER.hh"
#include "auto/RVRT.hh"
#include "auto/RREL.hh"
#include "auto/RRRT.hh"
#include "auto/HITB.hh"
#include "auto/RTHI.hh"
#include "auto/HITC.hh"
#include "auto/RTHC.hh"
#include "auto/RPNT.hh"
#include "auto/RTRP.hh"
#include "auto/MTRA.hh"
#include "auto/RTMT.hh"
#include "auto/RSEG.hh"
#include "auto/RTRS.hh"
#include "auto/RCCL.hh"
#include "auto/RTRC.hh"
#include "auto/RTRA.icc"
#endif
