*CMZ :  3.01/00 19/08/96  18.26.03  by  Siegmund Nowak
*CMZ :  2.00/00 22/12/95  13.01.04  by  Siegmund Nowak
*-- Author :    Siegmund Nowak  and Michael Walter 6/92
C
      SUBROUTINE WTLMED
C-----------------------

C     DEFINE MATERIAL CONSTANTS AND MEDIA FOR AACHEN AND NIKHEF CHAMBERS

      IMPLICIT NONE
#include "gean/ZGOTR.fi"

      REAL VOL_MIX(3)
      CHARACTER*12 NAM_MIX(3)

      NAM_MIX(1) = 'MYLAR'
      NAM_MIX(2) = 'OTR_GAS'
      NAM_MIX(3) = 'COPPER'


C     Honeycomb tubes 10 mm single
      VOL_MIX(1) = 4.*DLS1WT + 2.*DLWEWT
      VOL_MIX(2) = 1.5*DLCLWT(1) - 4.*(DLS1WT+DLS2WT)
      VOL_MIX(3) = 4.*DLS2WT
      CALL CRMIXT('OTR_WS10',12,3,NAM_MIX,VOL_MIX)

C     Honeycomb tubes 5 mm single
      VOL_MIX(2) = 1.5*DLCLWT(2) - 4.*(DLS1WT+DLS2WT)
      CALL CRMIXT('OTR_WS5',15,3,NAM_MIX,VOL_MIX)

C     Honeycomb tubes 10 mm double
      VOL_MIX(1) = 6.666667*DLS1WT + 2.*DLWEWT
      VOL_MIX(2) = 2.5*DLCLWT(3) - 6.666667*(DLS1WT+DLS2WT)
      VOL_MIX(3) = 6.666667*DLS2WT
      CALL CRMIXT('OTR_WD10',4,3,NAM_MIX,VOL_MIX)

C     Honeycomb tubes WT 5 mm double
      VOL_MIX(2) = 2.5*DLCLWT(4) - 6.666667*(DLS1WT+DLS2WT)
      CALL CRMIXT('OTR_WD5',5,3,NAM_MIX,VOL_MIX)

      RETURN

      END

