*-- Author :    Rainer Mankel   01/08/94

      subroutine prhits()

*     **** print hit information
      implicit none
      integer id1, id2, nch, isl, ipl, ih, imc, 
     +     mimp, nhmimp, ndetpl, nhitot, nmctot,
     +     tuhrtra, kpl, ksl, kmimp, kmc, krhit, jauxmi,
     +     ncorrect,ialia,nline, krtra, iirhit, ind_rhit, rh
      real xmc, ymc, mxmc, mymc, zmc, pmc

      character*80 chopts
      character*10 ch4
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/RHIT.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/RHIT.ff"

*     **** parameters
      call kugeti(id1)
      call kugeti(id2)
      call kugeti(kpl)
      call kugeti(ksl)
      call kugeti(kmimp)
      call kugeti(kmc)
      call kugeti(krtra)
      call kugeti(krhit)
      call kugetc(chopts,nch)

*     **** fixup
      if (jhitb.le.0) then
         call mewarn('prhits: table HITB is not booked')
         go to 999
      endif

      if (id1.eq.0) then
         id1 = 1
         if (id2.eq.0) id2 = nhitb()
      else
         if (id2.eq.0) id2 = id1
      endif

      ndetpl = iq(jgede+2)
      nhitot = iq(jhitb+2)
      nmctot = iq(jmtra+2)

      nline = 0

*     **** loop over range
      id1 = max(id1,1)
      id2 = min(id2,nhitot)
      do 10 ih=id1,id2
         ipl = ihitb_gede(ih)
         if (kpl.gt.0.and.ipl.ne.kpl) go to 10
         isl = ogede_gesl(ipl)
         if (ksl.gt.0.and.isl.ne.ksl) go to 10
         write(ch4,'(i8)')   0
*        **** get associated mimp
         call tuhmimp(ih,imc,mimp,nhmimp)
         
         if (kmimp.gt.0.or.kmc.gt.0) then
            ncorrect = 0
            do 20 ialia=1,99
               if (ialia.eq.1) then
                  jauxmi = phitb_mimp(ih)
               else
                  jauxmi = xhitb_mimp(jauxmi)
               endif
               if (jauxmi.eq.0) go to 21
               if (kmimp.eq.0.or.mhitb_mimp(jauxmi).eq.kmimp) then
                  if (kmc.eq.0
     +                 .or.omimp_mtra(mhitb_mimp(jauxmi)).eq.kmc) then
                     ncorrect = ncorrect + 1
                     go to 21
                  endif
               endif
 20         continue
 21         continue
            if (ncorrect.le.0) go to 10 ! no suitable mimp found
         endif

*        **** check rtra
         if (krtra.gt.0.or.krhit.gt.0) then
            ncorrect = 0
            do 30 iirhit=1,99
               if (iirhit.eq.1) then
                  ind_rhit = phitb_rhit(ih)
               else
                  ind_rhit = xhitb_rhit(ind_rhit)
               endif
               if (ind_rhit.eq.0) go to 31
               rh = mhitb_rhit(ind_rhit)
               if (krtra.gt.0) then
                  if (irhit_rtra(rh).eq.krtra) ncorrect = ncorrect + 1
               endif
               if (krhit.gt.0) then
                  if (rh.eq.krhit) ncorrect = ncorrect + 1
               endif
 30         continue
 31         continue
            if (ncorrect.le.0) go to 10
         endif

         if (nhmimp.gt.0) then
            imc  = omimp_mtra(mimp)
            xmc  = fmimp_x(mimp)
            ymc  = fmimp_y(mimp)
            mxmc = fmimp_tx(mimp)
            mymc = fmimp_ty(mimp)
            zmc  = fmimp_z(mimp)
            pmc  = fmimp_p(mimp)
         else
            imc = 0
            xmc = 0.
            ymc = 0.
            mxmc = 0.
            mymc = 0.
            zmc = 0.
            pmc = 0.
         endif

         nline = nline + 1

         if (mod(nline,10).eq.1) then ! print headline
            print 102,'ih','pl','sl',
     +           'z','x','y','q','r','gede','rtra','mtra', 'xmc',
     +           'ymc','txmc','tymc'
         endif

         print 101,ih,ipl,isl,
     +        fhitb_z(ih), fhitb_x(ih), fhitb_y(ih), fhitb_q(ih),
     +        fhitb_r(ih),
     +        ihitb_gede(ih), tuhrtra(ih), imc, xmc, ymc, mxmc,
     +        mymc

 101     format(   i6,i5,i3,4f8.3,f8.5,
     +              i5,2i4,
     +              4f8.3)
 102     format(   a6,a5,a3,4a8,a8,
     +              a5,2a4,
     +              4a8)
 10   continue
       
 999  end


