* B.Fominykh  2.07.97
* make clusters
* updated 10.04.99 by B.Fominykh - no clusterization for all wires
* bug correction 20.04.1999 by B.Fominykh
*
      SUBROUTINE MURCLIN
C-    ==================
      IMPLICIT NONE
*
#include "murec/MUCTAB.fi"
#include "murec/MUCPAR.fi"
#include "murec/MUCZDT.fi"
      INTEGER  IWW(NHRLMX)
      INTEGER NHB,IRL,JH,JC,I,JHT,ITYP,JHBL,IPL,NCL,NHT,IH,IHT
      INTEGER ISTAR,ISTOP,IFIN,IH1,IH2,ICL,NNCL
      REAL DISWIR,D1,D2,DIST,SD,SX,SY,SDD,SXX,SYY,SSX,SSY
      REAL XPD1,XPD2,YPD1,YPD2,DXPD1,DXPD2,DYPD1,DYPD2,DISX,DISY
      REAL Y1,Y2,Y21,Y22
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "auto/HITB.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"
#include "auto/HITB.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
* how many hits
      NHB=IQ(JTMP9+2)
      IF(NHB.LE.0) THEN
        WRITE(LLOGF,*) '*** MURCLIN: no muon hits'
        GOTO 200
      ENDIF
*
      CALL VZERO(NMUCLL,NMRLAY)
      CALL VZERO(NMUACL,NMRLAY)
      CALL VZERO(JCLPT1,NMRLAY)
      IFIN=0
      SSX=0.
      SSY=0.
* loops over reco layers
      DO 100 IRL=1,NMRLAY
        IF(NMUDTL(IRL).LE.0) GOTO 100  ! no hits - nothing to do
* the case of one hit
        IF(NMUDTL(IRL).EQ.1) THEN
          CALL MMBOOK(JTMP8,1)
          JH=JTMP9+IQ(JTMP9+1)*(JHTPT1(IRL)-1)+2
          JC=JTMP8+IQ(JTMP8+1)*(IQ(JTMP8+2)-1)+2
          IQ(JH+13)=IQ(JTMP8+2)
          IQ(JC+1)=1
          DO I=2,12
            IQ(JC+I)=IQ(JH+I)
          ENDDO
          IQ(JC+13)=1
          IQ(JC+14)=1
          IQ(JC+15)=JHTPT1(IRL)
          IQ(JC+16)=IQ(JC+15)
          NMUCLL(IRL)=1
          NMUACL(IRL)=1
          JCLPT1(IRL)=IQ(JTMP8+2)
          GOTO 100
        ENDIF
* type of hits
        JHT=JTMP9+IQ(JTMP9+1)*(JHTPT1(IRL)-1)+2
        ITYP=IQ(JHT+5)
        JHBL=JHITB+IQ(JHITB+1)*(IQ(JHT+1)-1)+2
        IPL=IQ(JHBL+JHITB_GEDE)
* cluster analisys of wires
        IF(ITYP.NE.1) GOTO 23
        DISWIR = FGEDE_PIT(IPL)
        NCL=1
        NHT=1
        D1=Q(JHT+8)
        Y1=Q(JHT+9)
        Y2=Q(JHT+10)
        SD = D1
        SDD=D1**2
        IQ(JHT+13)=IQ(JTMP8+2)+1
        ISTAR=1
        ISTOP=0
* loops over hits in reco layer
        DO 20 IH=2,NMUDTL(IRL)
          IHT=JHTPT1(IRL)+IH-1
          JHT=JTMP9+IQ(JTMP9+1)*(IHT-1)+2
          D2=Q(JHT+8)
          DIST=ABS(D1-D2)
          D1=D2
          Y21=Q(JHT+9)
          Y22=Q(JHT+10)
          IF(Y21.NE.Y1) GOTO 15
          IF(Y22.NE.Y2) GOTO 15
*          IF(DIST.GT.DISWIR+0.3) GOTO 15
          GOTO 15
*            SD = SD+D1
*            SDD= SDD+D1**2
*            NHT=NHT+1
*            IQ(JHT+13)=IQ(JTMP8+2)+1
*            IF(IH.LT.NMUDTL(IRL)) GOTO 20
  14        ISTOP=1
  15      CONTINUE
            CALL MMBOOK(JTMP8,1)
            IF(NMUCLL(IRL).EQ.0) JCLPT1(IRL)=IQ(JTMP8+2)
            NMUCLL(IRL)=NMUCLL(IRL)+1
            IF(NHT.LE.NHMCLW) NMUACL(IRL)=NMUACL(IRL)+1
            JC=JTMP8+IQ(JTMP8+1)*(IQ(JTMP8+2)-1)+2
            IQ(JC+1)=1
* kill large clusters
            IF(NHT.GT.NHMCLW) IQ(JC+1)=0
***
            DO I=2,7
              IQ(JC+I)=IQ(JHT+I)
            ENDDO
* measurement
            Q(JC+8) =SD/REAL(NHT)
            Q(JC+9) =Y1
            Q(JC+10)=Y2
* error of measurement
            IF(NHT.LE.2) Q(JC+11)=DISWIR/SQRT(12.)
            IF(NHT.GT.2)
     +        Q(JC+11)=SQRT(ABS(SDD/REAL(NHT)-Q(JC+8)**2))
            Q(JC+12)=0.
* relations to hits
            IQ(JC+13)=NHT
            IQ(JC+14)=NCL
            IQ(JC+15)=JHTPT1(IRL)+ISTAR-1
            IQ(JC+16)=JHTPT1(IRL)+IH-2+ISTOP
*
            ISTAR=IH
            NHT=1
            NCL=NCL+1
            SD = D1
            SDD= D1**2
            Y1=Q(JHT+9)
            Y2=Q(JHT+10)
            IF(ISTOP.EQ.0) IQ(JHT+13)=IQ(JTMP8+2)+1
            IF(IH.EQ.NMUDTL(IRL).AND.ISTOP.EQ.0) GOTO 14
  20    CONTINUE
*
* cluster analisys of pads
  23    CONTINUE
        IF(ITYP.NE.2) GOTO 63
        IF(NMUDTL(IRL).GT.NHRLMX) GOTO 63
        CALL VZERO(IWW,NHRLMX)
        NCL=0
  24    NCL=NCL+1
        NNCL=0
* reconstruction of clusters
        DO 41 IH1=1,NMUDTL(IRL)
          IF(NNCL.EQ.0.AND.IWW(IH1).EQ.0) THEN
            IWW(IH1)=NCL
            NNCL=1
          ENDIF
          IF(IWW(IH1).NE.NCL) GOTO 41
          IHT=JHTPT1(IRL)+IH1-1
          JHT=JTMP9+IQ(JTMP9+1)*(IHT-1)+2
          XPD1 =Q(JHT+8)
          YPD1 =Q(JHT+9)
          JHBL=JHITB+IQ(JHITB+1)*(IQ(JHT+1)-1)+2
          DXPD1=Q(JHBL+JHITB_Q)*0.5
          DYPD1=Q(JHBL+JHITB_R)*0.5

          DO 40 IH2=1,NMUDTL(IRL)
            IF(IWW(IH2).NE.0) GOTO 40
            IF(IH1.EQ.IH2) GOTO 40
            IHT=JHTPT1(IRL)+IH2-1
            JHT=JTMP9+IQ(JTMP9+1)*(IHT-1)+2
            XPD2 =Q(JHT+8)
            YPD2 =Q(JHT+9)
            JHBL=JHITB+IQ(JHITB+1)*(IQ(JHT+1)-1)+2
            DXPD2=Q(JHBL+JHITB_Q)*0.5
            DYPD2=Q(JHBL+JHITB_R)*0.5
*
            DISX=ABS(XPD1-XPD2)
            DISY=ABS(YPD1-YPD2)
            IF(DISX-0.3.LE.DXPD1+DXPD2) THEN
              IF(DISY-0.3.LE.DYPD1+DYPD2) THEN
                IWW(IH2)=NCL
                NNCL=NNCL+1
              ENDIF
            ENDIF
  40      CONTINUE
  41    CONTINUE
        IF(NNCL.GT.0) GOTO 24
        IF(NCL.LT.1)  GOTO 63
* save clusters to temporary table
        DO 60 ICL=1,NCL
          NHT=0
          SX =0.
          SY =0.
          SXX=0.
          SYY=0.
          ISTAR=0
          DO 50 I=1,NMUDTL(IRL)
            IF(IWW(I).NE.ICL) GOTO 50
            IF(ISTAR.EQ.0) ISTAR=I
            IFIN=I
            IHT=JHTPT1(IRL)+I-1
            JHT=JTMP9+IQ(JTMP9+1)*(IHT-1)+2
            NHT=NHT+1
            SX = SX + Q(JHT+8)
            SY = SY + Q(JHT+9)
            SSX= Q(JHT+11)
            SSY= Q(JHT+12)
            SXX= SXX + Q(JHT+8)**2
            SYY= SYY + Q(JHT+9)**2
            IQ(JHT+13)=IQ(JTMP8+2)+1
  50      CONTINUE
          IF(NHT.LT.1) GOTO 60
*
          CALL MMBOOK(JTMP8,1)
          IF(NMUCLL(IRL).EQ.0) JCLPT1(IRL)=IQ(JTMP8+2)
          NMUCLL(IRL)=NMUCLL(IRL)+1
          IF(NHT.LE.NHMCLP) NMUACL(IRL)=NMUACL(IRL)+1
          JC=JTMP8+IQ(JTMP8+1)*(IQ(JTMP8+2)-1)+2
          IQ(JC+1)=1
* kill large clusters
          IF(NHT.GT.NHMCLP) IQ(JC+1)=0
***
          DO I=2,7
            IQ(JC+I)=IQ(JHT+I)
          ENDDO
* measurement
          Q(JC+8) =SX/REAL(NHT)
          Q(JC+9) =SY/REAL(NHT)
          Q(JC+10)=0.
* error of measurement
          Q(JC+11)=
     +    SQRT(ABS(SXX/REAL(NHT)-Q(JC+8)**2))
          Q(JC+12)=
     +    SQRT(ABS(SYY/REAL(NHT)-Q(JC+9)**2))
          IF(Q(JC+11).LT.SSX) Q(JC+11)=SSX
          IF(Q(JC+12).LT.SSY) Q(JC+12)=SSY
* relations to hits
          IQ(JC+13)=NHT
          IQ(JC+14)=ICL
          IQ(JC+15)=JHTPT1(IRL)+ISTAR-1
          IQ(JC+16)=JHTPT1(IRL)+IFIN -1
          IQ(JC+17)=0
  60      CONTINUE
*
* cluster analisys of pixels
  63    CONTINUE
        IF(ITYP.NE.3) GOTO 100
        IF(NMUDTL(IRL).GT.NHRLMX) GOTO 100
        CALL VZERO(IWW,NHRLMX)
        NCL=0
  64    NCL=NCL+1
        NNCL=0
* reconstruction of clusters
        DO 71 IH1=1,NMUDTL(IRL)
          IF(NNCL.EQ.0.AND.IWW(IH1).EQ.0) THEN
            IWW(IH1)=NCL
            NNCL=1
          ENDIF
          IF(IWW(IH1).NE.NCL) GOTO 71
          IHT=JHTPT1(IRL)+IH1-1
          JHT=JTMP9+IQ(JTMP9+1)*(IHT-1)+2
          JHBL=JHITB+IQ(JHITB+1)*(IQ(JHT+1)-1)+2
          XPD1 =Q(JHBL+JHITB_X)
          YPD1 =Q(JHBL+JHITB_Y)
          DXPD1=Q(JHBL+JHITB_Q)*0.5
          DYPD1=Q(JHBL+JHITB_R)*0.5

          DO 70 IH2=1,NMUDTL(IRL)
            IF(IWW(IH2).NE.0) GOTO 70
            IF(IH1.EQ.IH2)    GOTO 70
            IHT=JHTPT1(IRL)+IH2-1
            JHT=JTMP9+IQ(JTMP9+1)*(IHT-1)+2
            JHBL=JHITB+IQ(JHITB+1)*(IQ(JHT+1)-1)+2
            XPD2 =Q(JHBL+JHITB_X)
            YPD2 =Q(JHBL+JHITB_Y)
            DXPD2=Q(JHBL+JHITB_Q)*0.5
            DYPD2=Q(JHBL+JHITB_R)*0.5
*
            DISX=ABS(XPD1-XPD2)
            DISY=ABS(YPD1-YPD2)

            IF(DISX-0.1.LE.DXPD1+DXPD2) THEN
              IF(DISY-0.1.LE.DYPD1+DYPD2) THEN
                IWW(IH2)=NCL
                NNCL=NNCL+1
              ENDIF
            ENDIF

  70      CONTINUE
  71    CONTINUE
        IF(NNCL.GT.0) GOTO 64
        IF(NCL.LT.1)  GOTO 100
* save clusters to temporary table
        DO 80 ICL=1,NCL
          NHT=0
          SX =0.
          SY =0.
          SXX=0.
          SYY=0.
          ISTAR=0
          DO 75 I=1,NMUDTL(IRL)
            IF(IWW(I).NE.ICL) GOTO 75
            IF(ISTAR.EQ.0) ISTAR=I
            IFIN=I
            IHT=JHTPT1(IRL)+I-1
            JHT=JTMP9+IQ(JTMP9+1)*(IHT-1)+2
            NHT=NHT+1
            SX = SX + Q(JHT+8)
            SY = SY + Q(JHT+9)
            SSX= Q(JHT+11)
            SSY= Q(JHT+12)
            SXX= SXX + Q(JHT+8)**2
            SYY= SYY + Q(JHT+9)**2
  75      CONTINUE
          IF(NHT.LT.1) GOTO 80
*
          CALL MMBOOK(JTMP8,1)
*
          DO 76 I=1,NMUDTL(IRL)
            IF(IWW(I).NE.ICL) GOTO 76
            IHT=JHTPT1(IRL)+I-1
            JHT=JTMP9+IQ(JTMP9+1)*(IHT-1)+2
            IQ(JHT+13)=IQ(JTMP8+2)
  76      CONTINUE
          IF(NMUCLL(IRL).EQ.0) JCLPT1(IRL)=IQ(JTMP8+2)
          NMUCLL(IRL)=NMUCLL(IRL)+1
          IF(NHT.LE.NHMCLX) NMUACL(IRL)=NMUACL(IRL)+1
          JC=JTMP8+IQ(JTMP8+1)*(IQ(JTMP8+2)-1)+2
          IQ(JC+1)=1
* kill large clusters
          IF(NHT.GT.NHMCLX) IQ(JC+1)=0
***
          DO I=2,7
            IQ(JC+I)=IQ(JHT+I)
          ENDDO
* measurement
          Q(JC+8) =SX/REAL(NHT)
          Q(JC+9) =SY/REAL(NHT)
          Q(JC+10)=0.
* error of measurement
          Q(JC+11)=
     +    SQRT(ABS(SXX/REAL(NHT)-Q(JC+8)**2))
          IF(Q(JC+11).LT.SSX) Q(JC+11)=SSX
          Q(JC+12)=
     +    SQRT(ABS(SYY/REAL(NHT)-Q(JC+9)**2))
          IF(Q(JC+12).LT.SSY) Q(JC+12)=SSY
* relations to hits
          IQ(JC+13)=NHT
          IQ(JC+14)=ICL
          IQ(JC+15)=JHTPT1(IRL)+ISTAR-1
          IQ(JC+16)=JHTPT1(IRL)+IFIN -1
          IQ(JC+17)=0
  80      CONTINUE
*
 100  CONTINUE
*
 200  CONTINUE
      RETURN
      END
