*-- Author :    Rainer Mankel   08/11/93

      subroutine di1rtra(rt,islsta,islend,chopt)

*     **** display reconstructed tracks
      implicit none
#include "pris/zgraf.fi"
#include "arte/Arte.fi"
      integer max_graf
      parameter (max_graf=200)
      integer rt, rh, ngraf, islsta, islend, isl, ipl, i_sort, n_sort,
     +     rh_sort(max_graf), 
     +     iirh, indx_rhit,
     +     rp, iirp, indx_rpnt, smk, rr, rv, rcl

      real wh(5), xxx(max_graf), yyy(max_graf), sna, zzz(max_graf),
     +     ltyp, lwid, txci, oin(max_graf)
      character*(*) chopt
      logical lplus, lzero, lplsup, spl
      character*2 opt_c, opt_l
      character*10 cnpart
#include "auto/RHIT.fi"
#include "auto/RTRA.fi"
#include "auto/RREL.fi"
#include "auto/RVER.fi"
#include "auto/RPNT.fi"
#include "auto/RCCL.fi"
#include "auto/HITB.fi"
#include "auto/GESL.fi"
#include "auto/GEDE.fi"

#include "arte/Arte.ff"
#include "auto/RHIT.ff"
#include "auto/RTRA.ff"
#include "auto/RREL.ff"
#include "auto/RVER.ff"
#include "auto/RPNT.ff"
#include "auto/RCCL.ff"
#include "auto/HITB.ff"
#include "auto/GESL.ff"
#include "auto/GEDE.ff"

*     **** stereo mode option
      lplus = index(chopt,'Y').gt.0
      lzero = index(chopt,'0').gt.0
      lplsup = lplus.or.lzero

*     **** ghosts option
      if (index(chopt,'U').gt.0) then
       if (prtra_mtra(rt).gt.0) go to 999
      endif

*     **** colour index
      call igset('PLCI',corczg)
      call igset('PMCI',corczg)
      call igset('LTYP',1.)
      call igset('LWID',6.)

      n_sort = 0

*     **** locate vertex
      if (lrverzg.and.iviewzg.ne.11) then
         if (prtra_rrel(rt).gt.0) then
            rr = mrtra_rrel(prtra_rrel(rt))
            if (rr.gt.0) then
               rv = orrel_rver(rr)
#ifdef FULL
               print *,' vertex for rt=',rt,' is ',rv
#endif
               if (xrtra_rrel(rr).ne.0) then
                  print *,' di1rtra: more than 1 vertex for rt=',
     +                 rt
               endif
               if (n_sort.lt.max_graf) then
                  n_sort = n_sort + 1
#ifndef NOCONSTRAINT
                  wh(1) = frver_xv(rv)
                  wh(2) = frver_yv(rv)
                  wh(3) = frver_zv(rv)
#else
                  wh(1) = frtra_xf(rt)
     +                 + (frver_zv(rv)-frtra_zf(rt)-.1) * frtra_txf(rt)
                  wh(2) = frtra_yf(rt)
     +                 + (frver_zv(rv)-frtra_zf(rt)-.1) * frtra_tyf(rt)
                  wh(3) = frver_zv(rv)-.1
#endif
                  wh(4) = 0.
                  wh(5) = 0.
                  call dipro5(wh,xxx(n_sort),yyy(n_sort))
                  zzz(n_sort) = wh(3)
               endif
            else
               print *,' () di1rtra: overflowing n_sort=', n_sort
               stop 'di1rtra'
            endif
         endif
      endif




*     **** loop over reconstructed hits

      do 10 rh=1,iq(jrhit+2)
         if (irhit_rtra(rh).ne.rt) go to 10
         if (index(chopt,'L').gt.0)
     +        print *,' di1rtra: display RHIT=', rh
         ipl = ihitb_gede(orhit_hitb(rh))
         isl = ogede_gesl(ipl)
         if (isl.lt.islsta.or.isl.gt.islend) go to 10
         if (modezg.eq.1) then
            if (isl.gt.scmxzg) go to 10
            if (.not.lscopzg(isl)) go to 10
         endif

*        **** check plane
         if (lplsup) then
            sna = abs( fgede_sin(ipl) )
            if (sna.gt.1.e-10.and.lzero) go to 10
            if (sna.le.1.e-10.and.lplus) go to 10
         endif

         if (n_sort.lt.max_graf) then
            n_sort = n_sort + 1
            wh(1) = frhit_x(rh)
            wh(2) = frhit_y(rh)
            wh(3) = fhitb_z(orhit_hitb(rh))
            wh(4) = atan(frhit_tx(rh))
            wh(5) = atan(frhit_ty(rh))
            call dipro5(wh,xxx(n_sort),yyy(n_sort))
            zzz(n_sort) = wh(3)
         else
            print *,' () di1rtra: overflowing n_sort=', n_sort
            stop 'di1rtra'
         endif
 10   continue
 11   continue


#ifdef RPNT
*     **** loop over reconstructed points
      do 20 iirp=1,999
         if (iirp.eq.1) then
            indx_rpnt = prtra_rpnt(rt)
         else
            indx_rpnt = xrtra_rpnt(indx_rpnt)
         endif
         if (indx_rpnt.le.0) go to 21
         rp = mrtra_rpnt(indx_rpnt)
         if (index(chopt,'L').gt.0)
     +        print *,' di1rtra: display RPNT=', rp
#ifdef LATER
         if (isl.lt.islsta.or.isl.gt.islend) go to 20
         if (modezg.eq.1) then
            if (isl.gt.scmxzg) go to 20
            if (.not.lscopzg(isl)) go to 20
         endif

*        **** check plane
         if (lplsup) then
            sna = abs( fgede_sin(ipl))
            if (sna.gt.1.e-10.and.lzero) go to 20
            if (sna.le.1.e-10.and.lplus) go to 20
         endif
#endif

         if (n_sort.lt.max_graf) then
            n_sort = n_sort + 1
            zzz(n_sort) = frpnt_zf(rp)
            wh(1) = frpnt_xf(rp) ! 3D point from RPNT
            wh(2) = frpnt_yf(rp)
            wh(3) = frpnt_zf(rp)
            wh(4) = atan(frpnt_txf(rp))
            wh(5) = atan(frpnt_tyf(rp))
            call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
         else
            print *,' () di1rtra: overflowing n_sort=', n_sort
            stop 'di1rtra'
         endif
 20   continue
 21   continue
#endif

*     **** locate associated cluster
      if (jrccl.gt.0) then
         if (prtra_rccl(rt).gt.0) then
            rcl = mrtra_rccl(prtra_rccl(rt))
            if (n_sort.lt.max_graf) then
               n_sort = n_sort + 1
               zzz(n_sort) = frccl_z(rcl)
               wh(1) = frccl_x(rcl) ! 3D point from RCCL
               wh(2) = frccl_y(rcl)
               wh(3) = frccl_z(rcl)
               wh(4) = atan(frccl_tx(rcl))
               wh(5) = atan(frccl_ty(rcl))
               call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
            else
               print *,' () di1rtra: overflowing n_sort=', n_sort
               stop 'di1rtra'
            endif
         endif
      endif
            

*     **** draw the graph
      if (lcrosszg) then
         call ismk(28)          ! set marker type
         call ismksc(1.5)       ! marker scale factor
         opt_l = 'LP'
         opt_c = 'CP'
      else
         opt_l = 'L'
         opt_c = 'C'
      endif


      lwid = widrczg
      spl = lsplinezg.and.abs(frtra_pf(rt)).gt.1
      txci = corczg

      cnpart = ' '
*      if (ltypezg) then         ! particle label option
*         if (gcode.ge.1.and.gcode.le.maxgcode) then
*            cnpart = cn(gcode)
*         else
*            cnpart = ' '
*         endif
*      endif

      smk = 0
      if (lcrosszg) smk = 28

      call ditraj(n_sort,xxx,yyy,zzz,zzz,lwid,ltyp,spl,.true.,
     +     .true.,smk,txci,cnpart)

*     **** draw RPNT markers
      if (lcrosszg) then
         n_sort = 0
         do 30 iirp=1,999
            if (iirp.eq.1) then
               indx_rpnt = prtra_rpnt(rt)
            else
               indx_rpnt = xrtra_rpnt(indx_rpnt)
            endif
            if (indx_rpnt.le.0) go to 31
            rp = mrtra_rpnt(indx_rpnt)

            if (n_sort.lt.max_graf) then
               n_sort = n_sort + 1
               zzz(n_sort) = frpnt_zf(rp)
               wh(1) = frpnt_xf(rp) ! 3D point from RPNT
               wh(2) = frpnt_yf(rp)
               wh(3) = frpnt_zf(rp)
               wh(4) = atan(frpnt_txf(rp))
               wh(5) = atan(frpnt_tyf(rp))
               call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
               call ismk(24)    ! set marker type
               call ismksc(3.0) ! marker scale factor
               call ipm(1,xxx(n_sort),yyy(n_sort))
            else
               print *,' () di1rtra: overflowing n_sort=', n_sort
               stop 'di1rtra'
            endif
 30      continue
 31      continue
      endif

 999  end


