*-- Author :    Rainer Mankel   30/01/97
*-- changed:   A.Spiridonov    21/05/98    !  call tfstam1 for ideal ranger
*-- changed:   A.Spiridonov    02/11/98    !  rlevel_zfpar = 4 

#undef TC_TIME
      subroutine tfevnt()

*     **** mother routine for pattern recognition in main tracker system
      implicit none
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "arte/Arte.fi"

      integer istat
      integer message_id_1
      data message_id_1 /0/
#include "arte/Arte.ff"

      if (jgede.le.0.or.jgesl.le.0.or.jhitb.le.0) then
         call mepric(message_id_1,1,
     +           'tfevnt: one of tables GEDE/GESL/HITB is not booked')
         go to 999
      endif

      call rginit()
      if (.not.l_rinit) call tfrinit()

      if (rlevel_zfpar.eq.0) then

         call rgideal(1.,29,190.,1330.,0) ! full ideal analysis

      elseif (rlevel_zfpar.le.2) then        ! rlevel_zfpar < 3          

         call tfmatrip(istat)   ! ranger/triplet

      elseif (rlevel_zfpar.eq.3) then        !  rlevel_zfpar = 3          

         call tfmatrip(istat)   ! ranger/triplet

      elseif (rlevel_zfpar.eq.4) then         ! rlevel_zfpar = 4

         call tfmatrip(istat)   ! ranger/triplet

         call tftcre(istat)     ! track reconstruction in TC chambers

      endif

      if(rlevel_zfpar.ge.2) then

         call tfunco()          ! weedout

         call tfunrf()          ! segments fit

      end if

 999  end
