
*-- Author :    Rainer Mankel   27/07/95
*-- changed:    A. Spiridonov   25/02/98

      subroutine tfsegfill(iseg,x,cx,x_zmax,cx_zmax)

*     **** fill track parameters into segment table entry iseg
      implicit none
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/RSEG.fi"

#include "rang/zfpar.fi"
      double precision x(5), cx(5,5), d_mx, d_my, d_qpt, sq,
     +     x_zmax(5),cx_zmax(5,5),sq_zmax
      integer iseg, i_pack, i, j
#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/RSEG.ff"

*     **** fill track parameters for first point

      q(qrseg_xf(iseg))  = x(1)
      q(qrseg_yf(iseg))  = x(2)
      q(qrseg_txf(iseg)) = x(3)
      q(qrseg_tyf(iseg)) = x(4)
      q(qrseg_pf(iseg))  = x(5)

*      **** covariance of track parameters
      do i=1,5
         do j=i,5               ! packing
            i_pack = matrix_pack(i,j)
            q(qrseg_cvf(i_pack,iseg)) =  
     +           f_cov_zfpar(i) * f_cov_zfpar(j) * cx(i,j)
         enddo
      enddo

*     **** fill track parameters for last point

      q(qrseg_xe(iseg))  = x_zmax(1)
      q(qrseg_ye(iseg))  = x_zmax(2)
      q(qrseg_txe(iseg)) = x_zmax(3)
      q(qrseg_tye(iseg)) = x_zmax(4)
      q(qrseg_pe(iseg))  = x_zmax(5)

*      **** covariance of track parameters
      do i=1,5
         do j=i,5               ! packing
            i_pack = matrix_pack(i,j)
            if (dabs(cx_zmax(i,j)).gt.1.d-30) then ! avoid underflow
               q(qrseg_cve(i_pack,iseg)) = sngl( cx_zmax(i,j) )
            else
               q(qrseg_cve(i_pack,iseg)) = 0.
            endif
         enddo
      enddo

      end
