#include "OTrWire.hh"

//__________________________________________________________________
//
// OTrWire
//
// A wire has a pointer to a channel, a wirenumber and a pointer to a section (gede).
//
// Author: Ivar Siccama and Wouter Hulsbergen
//__________________________________________________________________


#ifdef USE_ROOT
ClassImp(OTrWire) ;
#endif

OTrWire::~OTrWire() {} ;

OTrWire::OTrWire() :
  OTrDetectorComponent(),
  fChannel(0), fSection(0), fWireNumber(0) {} ;


OTrWire::OTrWire( const int wirenr, OTrSection* mother, ComponentId_t id ) :
  OTrDetectorComponent(id), fChannel(0), fSection(mother), fWireNumber(wirenr)
{ 
  //Dump() ;
}

void OTrWire::Dump(ostream& os) const
{
  os << "wire dump: " << endl;
  OTrDetectorComponent::Dump(os) ;
}

