#ifdef USE_ARTE
      function next_arte()
************************************************************************
*
* Description: run one event in ARTE (adapted from kart/kaexec.F)
*
* Called from: ROOT
*
* Returns: 0 in case of success, 1 otherwise (e.g. if there is end of file)
* 
* Author: A.Lanyov    21-Nov-1998
* 
************************************************************************
      implicit none
      integer next_arte

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"

#include "arte/Arte.ff"

      next_arte = 0
      write (*,*) 'NEXT_ARTE started'
      if (datdinit .ne. 0)  then
        call ddexec
        go to 90
      end if

      neventl = 1
c      if (neventl .eq. 0)  then
c        neventl = 1
c        if (ibatch .ne. 0)  neventl = ilargest
c      end if

c#ifdef USE_NEWARTE
      call qnexte
c#else
c    call atevnt
c#endif

C      if (iioflg(levi1).eq.4 .or. iioflg(levi1).eq.5) then
C         write (*,*) 'NEXT_ARTE: ************* No more events at EVIN1'
C         next_arte = 1
C      end if

 90   continue
      write (*,*) 'NEXT_ARTE finished and returns ',next_arte
      return
      end
#endif





