*CMZ :  2.01/01 06/09/95  16.56.20  by  Hartwig ALbrecht
*-- Author :    Hartwig Albrecht   06/09/95

      INTEGER FUNCTION TPNAME (CINP)

************************************************************************
*
* Description: get Arte particle code from name - fast version
*
* Called from: anywhere
*
* External references: TPNAM1
*
* Argument in/out description
*   CINP   in     particle name
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/TOPP.fi"

      INTEGER ND
      PARAMETER (ND = 32)
      INTEGER N, LINP, TPNAM1, NCMP(9), ICMP(ND,9)

      CHARACTER *(*) CINP
      CHARACTER *  1 CMP 1(ND)
      CHARACTER *  2 CMP 2(ND)
      CHARACTER *  3 CMP 3(ND)
      CHARACTER *  4 CMP 4(ND)
      CHARACTER *  5 CMP 5(ND)
      CHARACTER *  6 CMP 6(ND)
      CHARACTER *  7 CMP 7(ND)
      CHARACTER *  8 CMP 8(ND)
      CHARACTER * 12 CMP12(ND), CNAM

      DATA NCMP /9 * 0/
      SAVE NCMP, ICMP

#include "arte/Arte.ff"
#include "auto/TOPP.ff"

      LINP = MIN (LEN (CINP), 9)
      GO TO (10,20,30,40,50,60,70,80,90), LINP
C
 10   IF (CINP(1:1) .EQ. ' ')  THEN
        TPNAME = 0
        GO TO 900
      ENDIF
C
      DO 11 N = 1, NCMP(1)
        IF (CINP(1:1) .EQ. CMP1(N))  THEN
          TPNAME = ICMP(N,1)
          GO TO 900
        ENDIF
 11   CONTINUE
      GO TO 200
C
 20   DO 21 N = 1, NCMP(2)
        IF (CINP(1:2) .EQ. CMP2(N))  THEN
          TPNAME = ICMP(N,2)
          GO TO 900
        ENDIF
 21   CONTINUE
      GO TO 200
C
 30   DO 31 N = 1, NCMP(3)
        IF (CINP(1:3) .EQ. CMP3(N))  THEN
          TPNAME = ICMP(N,3)
          GO TO 900
        ENDIF
 31   CONTINUE
      GO TO 200
C
 40   DO 41 N = 1, NCMP(4)
        IF (CINP(1:4) .EQ. CMP4(N))  THEN
          TPNAME = ICMP(N,4)
          GO TO 900
        ENDIF
 41   CONTINUE
      GO TO 200
C
 50   DO 51 N = 1, NCMP(5)
        IF (CINP(1:5) .EQ. CMP5(N))  THEN
          TPNAME = ICMP(N,5)
          GO TO 900
        ENDIF
 51   CONTINUE
      GO TO 200
C
 60   DO 61 N = 1, NCMP(6)
        IF (CINP(1:6) .EQ. CMP6(N))  THEN
          TPNAME = ICMP(N,6)
          GO TO 900
        ENDIF
 61   CONTINUE
      GO TO 200
C
 70   DO 71 N = 1, NCMP(7)
        IF (CINP(1:7) .EQ. CMP7(N))  THEN
          TPNAME = ICMP(N,7)
          GO TO 900
        ENDIF
 71   CONTINUE
      GO TO 200
C
 80   DO 81 N = 1, NCMP(8)
        IF (CINP(1:8) .EQ. CMP8(N))  THEN
          TPNAME = ICMP(N,8)
          GO TO 900
        ENDIF
 81   CONTINUE
      GO TO 200
C
 90   CNAM = CINP
      DO 91 N = 1, NCMP(9)
        IF (CNAM .EQ. CMP12(N))  THEN
          TPNAME = ICMP(N,9)
          GO TO 900
        ENDIF
 91   CONTINUE
C
 200  TPNAME = TPNAM1 (CINP)
      IF (TPNAME .EQ. 0)  GO TO 900
C
C       fill internal table
C
      IF (NCMP(LINP) .EQ. ND)  THEN
        CALL MEWARC (653434, 5,
     +    'TPNAME: Internal search buffer too short')
        GO TO 900
      ENDIF
      NCMP(LINP) = NCMP(LINP) + 1
      ICMP(NCMP(LINP),LINP) = TPNAME
      GO TO (210,220,230,240,250,260,270,280,290), LINP
C
 210  CMP1(NCMP(1)) = CINP(1:1)
      GO TO 900
C
 220  CMP2(NCMP(2)) = CINP(1:2)
      GO TO 900
C
 230  CMP3(NCMP(3)) = CINP(1:3)
      GO TO 900
C
 240  CMP4(NCMP(4)) = CINP(1:4)
      GO TO 900
C
 250  CMP5(NCMP(5)) = CINP(1:5)
      GO TO 900
C
 260  CMP6(NCMP(6)) = CINP(1:6)
      GO TO 900
C
 270  CMP7(NCMP(7)) = CINP(1:7)
      GO TO 900
C
 280  CMP8(NCMP(8)) = CINP(1:8)
      GO TO 900
C
 290  CMP12(NCMP(9)) = CNAM
C
 900  END

************************************************************************
* End of TPNAME
************************************************************************
