*-- Author :    Hartwig Albrecht   06/08/98

      INTEGER FUNCTION UTTABNF (CNAME)

************************************************************************
*
* Description: get link number from table name (Fortran string)
*
* Called from: KUIP
*
* External references: MMTFIL, KUIP
*
* Arguments: CNAME in: table name 
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"

      INTEGER I, H(NAMELEN)
      CHARACTER CNAME*(*)

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      CALL CHCTOH (CNAME, H, NAMELEN)

      DO 10 UTTABNF = 1, NMEMO()
        DO  I = 1, NAMELEN
          IF (H(I) .NE. hMEMO_NAME(I,UTTABNF))  GO TO 10
        END DO
        GO TO 90
 10   CONTINUE
      UTTABNF = 0

 90   END

************************************************************************
* End of UTTABNF
************************************************************************
