//                              -*- Mode: C++ -*-
//:dgcal.hh
//
//
// Authors: Benedetto Giacobbe and Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: giacobbe@bo.infn.it, villa@bo.infn.it
//
// Created 29/8/97
// Last Update ........
//
#ifndef DGCAL_HH_
#define DGCAL_HH_

extern "C" {
  void dgcalinit_();       // dgcal initialization routine
  void dgcal_(int *isl);   // dgcal main routine
  void dgcal0_(int *isl);  // digi level 0 No readout 
  void dgcal1_(int *isl);  // digi level 1 ADC info in HITC bank
  void dgcal2_(int *isl); // digi level 2 DCAL bank produced
  float dgcal_enecalc(int ipl, int ix, int iy);
};

int dgcalech(int idcell, float mc_en);
float dgcalche(int idcell, int ch, float & fadc, float & enerr);

#endif // DGCAL_HH_
