#ifndef _NESL_HH_
#define _NESL_HH_
struct NESL_NEDE;
struct NESL_NCAL;
struct NESL_NWAL;
struct NESL {
   char name[4];
   int cmp;
   int shp;
   int nsl;
   int mfl;
   int lay;
   float x1;
   float x2;
   float y1;
   float y2;
   float z1;
   float z2;
   float dx;
   float dy;
   int npl;
   int fpl;
   int nwl;
   int fwl;
   int ltyp;
   ArteRelationPointer<NESL_NEDE> nede;
   ArteRelationPointer<NESL_NCAL> ncal;
   ArteRelationPointer<NESL_NWAL> nwal;
};
#include "auto/NEDE.hh"
#include "auto/NSND.hh"
#include "auto/NCAL.hh"
#include "auto/NSNC.hh"
#include "auto/NWAL.hh"
#include "auto/NSNW.hh"
#include "auto/NESL.icc"
#endif
