#ifndef _RTRA_H_
#define _RTRA_H_
typedef struct {
   float zf;
   float xf;
   float yf;
   float txf;
   float tyf;
   float pf;
   float cvf[15];
   int hsi;
   int hin;
   int hou;
   int hri;
   int hca;
   int htr;
   int hmu;
   int fit;
   float chi;
   float lre;
   float lrmu;
   float lrpi;
   float lrk;
   float lrp;
   int flr;
   int otopp;
   float lte;
   float lth;
   int flt;
   float lee;
   float lemi;
   float leh;
   int fle;
   float lmmu;
   float lmh;
   int flm;
   int oever;
   int prrel;
   int phitb;
   int phitc;
   int prpnt;
   int pmtra;
   int prseg;
   int prccl;
} RTRA;
#define  JRTRA (gcbank_.iq+artelink_.jrtra)
#define  NRTRA() N_U(JRTRA)
#define NCRTRA() N_C(JRTRA)
#define RTRA(i) (*((RTRA*)(JRTRA+2)+(i)-1))
#define RTRA_otopp(i) RTRA(i).otopp
#define RTRA_oever(i) RTRA(i).oever
#include "auto/RRRT.h"
#define RTRA_prrel(i) RTRA(i).prrel
#define RTRA_mrrel(i) M_R(i,JRRRT)
#define RTRA_xrrel(i) X_R(i,JRRRT)
#include "auto/RTHI.h"
#define RTRA_phitb(i) RTRA(i).phitb
#define RTRA_mhitb(i) M_2(i,JRTHI)
#define RTRA_xhitb(i) X_2(i,JRTHI)
#include "auto/RTHC.h"
#define RTRA_phitc(i) RTRA(i).phitc
#define RTRA_mhitc(i) M_2(i,JRTHC)
#define RTRA_xhitc(i) X_2(i,JRTHC)
#include "auto/RTRP.h"
#define RTRA_prpnt(i) RTRA(i).prpnt
#define RTRA_mrpnt(i) M_2(i,JRTRP)
#define RTRA_xrpnt(i) X_2(i,JRTRP)
#include "auto/RTMT.h"
#define RTRA_pmtra(i) RTRA(i).pmtra
#define RTRA_mmtra(i) M_2(i,JRTMT)
#define RTRA_xmtra(i) X_2(i,JRTMT)
#include "auto/RTRS.h"
#define RTRA_prseg(i) RTRA(i).prseg
#define RTRA_mrseg(i) M_2(i,JRTRS)
#define RTRA_xrseg(i) X_2(i,JRTRS)
#include "auto/RTRC.h"
#define RTRA_prccl(i) RTRA(i).prccl
#define RTRA_mrccl(i) M_2(i,JRTRC)
#define RTRA_xrccl(i) X_2(i,JRTRC)
#endif
