#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "digi/dglev.h"

static char kadglev_nam[] = "SVD OTR ITR PTL RIC TRD ECA MUD MXD";

extern "C" {
  char* ku_getc();
  int   ku_geti();
 
  void kadglev() {
    char buffer[4];
    strncpy(buffer, ku_getc(),3);
    buffer[3] ='\0';
    for (int i =0; i<9; i++) {
      if(!strncmp(buffer,&kadglev_nam[4*i],3)) {
         dglev_.idglev[i] = ku_geti();      return;
      }
    }
    arteMsg << "kadglev: detector component " << buffer << " not found";
    arteMsg.warn();
    arteMsg << "         it must be SVD OTR ITR PTL RIC TRD ECA MUD MXD";
    arteMsg.warn();
  }
}
