#include <math.h>
#include <vector.h>
#include "arte/arte.hh"
#include "arte/ArteUtil.h"
#include "gean/gctrak.h"
#include "gean/gckine.h"
#include "gean/gcvolu.h"
#include "gean/ZGMOTH.h"
#include "gean/zgkine.hh"
#include "gean/zgmimp.hh"

extern vector<hgmtra> *hg_mtra;
extern vector<hgmimp> *RICH_mimp;
extern "C" {
void crrihi_(float xxphot[] ) {

   hgmimp mm; 
   vector<hgmtra>::iterator mt = hg_mtra->begin() + gckine_.itra -1; 

         mm.z  = xxphot[2] - zgmoth_.ZZERO;
         mm.x  = xxphot[0];
         mm.y  = xxphot[1];
         mm.tx = xxphot[3]*xxphot[6];
         mm.ty = xxphot[4]*xxphot[6];
         mm.p  = xxphot[5]*xxphot[6]; 

/*  try to compress polarisation vector, so that mimp can
    be used to store photon
    This algorithm only works, if the integer to float conversion
    work one to one for any integer in the range -10000000 to +10000000.
    This true for ieee(sgi,hp), pc running linux */

         float phi=float(cos(xxphot[7]));
         if (xxphot[8] < 0.) phi=AR_TWOPI-phi;
         int iphi = int(phi * 1000.); 
         int icos = int (xxphot[9]* 1000.);
         mm.time = float(icos*10000 + iphi);        
         mm.itra = gckine_.itra;
         ArtePointer<GESL> gs(zgmoth_.RICHSL);
         mm.gede = gs->fpl;
         RICH_mimp->push_back(mm); 

         mt->nhit++;;
 }}
