      SUBROUTINE GPMATE (NUMB)
      IMPLICIT NONE
C.
C.    ******************************************************************
C.    *                                                                *
C.    *       Routine to print material data structures JMATE          *
C.    *       NUMB     Material number                                 *
C.    *                                                                *
C.    *      Changed by S.Egli at 8.5.90: also show mixture contents   *
C.    *                                                                *
C.    *    ==>Called by : <USER>, GPRINT                               *
C.    *       Author    R.Brun  *********                              *
C.    *                                                                *
C.    ******************************************************************

      INTEGER NUMB,N1,N2,I,J,JMA,NMIXT,JMX
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcnum.fi"
#include "arte/Arte.ff"
C.    ------------------------------------------------------------------

      IF (JMATE.LE.0) GO TO 999
      IF (NUMB .EQ.0) THEN
         WRITE (LLOGF,10000)
         N1     = 1
         N2     = NMATE
      ELSE
         N1     = ABS(NUMB)
         N2     = ABS(NUMB)
      ENDIF
      IF(NUMB.GE.0) THEN
         WRITE (LLOGF,10100)
         WRITE (LLOGF,10400)
      ENDIF
C
      DO 20 I=N1,N2
         JMA = LQ(JMATE-I)
         IF (JMA.LE.0) GO TO 20
C
         NMIXT=Q(JMA+11)
         WRITE (LLOGF,10200) I,(Q(JMA + J),J = 1,10),NMIXT
         IF(NMIXT.GT.1)THEN
            WRITE(LLOGF,10500)
            JMX=LQ(JMA-5)
            DO 10 J=1,NMIXT
               WRITE(LLOGF,10300)Q(JMX+J),Q(JMX+NMIXT+J),
     +         Q(JMX+2*NMIXT+J)
   10       CONTINUE
         ENDIF
   20 CONTINUE
C
10000 FORMAT (//28('='),5X,'MATERIALS',6X,28('=')/)
10100 FORMAT (6X,'MATERIAL',17X,'A',8X,'Z',4X,'DENSITY'
     +,1X,'RADIAT L',1X,'ABSORP L','  NMIXT')
10200 FORMAT (1X,I3,1X,5A4,2(1X,F8.3),1X,3(1X,G8.3),I4)
10300 FORMAT (51X,2F7.2,F7.3)
10400 FORMAT(1X,' ')
10500 FORMAT(51X,'   A       Z       W')
  999 END




