
      SUBROUTINE POTDAT

************************************************************************
*
* POTDAT
* written by Siegmund Nowak, 16/03/95 09.18.12
*
* Description: Reads ASCII geometry file and stores the data
*
* called from  POTGEO
*
* External references: IO..., FF..., ...KEY,
************************************************************************

      IMPLICIT NONE
      INTEGER LEN
      CHARACTER*80 FILNAM
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "gean/ZGRPOT.fi"
#include "arte/Arte.ff"

C---             Initialize geo dat input

      CALL ZGETFIL(filnam,len)
      CALL GEOPEN(filnam(:len))
      CALL FFINIT(0)

C     set keys for reading roman pot data cards by ffread

      CALL FFKEY('ZAPOT' ,ZAPOT , 1,'REAL')           	
      CALL FFKEY('DLPOT' ,DLPOT , 2,'REAL')           	
      CALL FFKEY('RIPOT' ,RIPOT , 2,'REAL')           	
      CALL FFKEY('WDPOT' ,WDPOT , 1,'REAL')           	
      CALL FFKEY('RRPES' ,RRPES , 1,'REAL')           	
      CALL FFKEY('ZAPES' ,ZAPES , 1,'REAL')           	
      CALL FFKEY('DPES'  ,DLPES , 1,'REAL')           	
      CALL FFKEY('RIPS'  ,RIPES , 1,'REAL')           	
      CALL FFKEY('ROPS'  ,ROPES , 1,'REAL')           	
      CALL FFKEY('DPET'  ,DLPET , 3,'REAL')           	
      CALL FFKEY('RIPET' ,RIPET , 3,'REAL')           	
      CALL FFKEY('WDPET' ,WDPET , 3,'REAL')           	
      CALL FFKEY('DPEC'  ,DLPEC , 3,'REAL')           	
      CALL FFKEY('RISPEC',RISPEC, 3,'REAL')           	
      CALL FFKEY('ROSPEC',ROSPEC, 3,'REAL')           	
      CALL FFKEY('RIEPEC',RIEPEC, 3,'REAL')           	
      CALL FFKEY('ROEPEC',ROEPEC, 3,'REAL')           	

C     Read in of data cards
      CALL FFSET('LINP',LREAD)
      CALL FFSET('LOUT',LLOGF)
      CALL FFGO
      CALL IOCLOS(LREAD)

 999  RETURN
      END

************************   END    POTDAT    *****************************




