
      SUBROUTINE WTLDAT(CNAME)

************************************************************************
*
* WTLDAT
* written by Siegmund Nowak, 16/03/95 09.18.12
*
* Description: Reads ASCII geometry file and stores the data 
*
* called from  WTLGEO
*
* External references: IO..., FF..., ...KEY,
************************************************************************

      IMPLICIT NONE
      INTEGER LENOCC
      CHARACTER*(*) CNAME

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/ZGOTR.fi"
#include "arte/Arte.ff"

C---             Initialize geo dat input

      CALL GEOPEN(CNAME(1:LENOCC(CNAME)))
      CALL FFINIT(0)

C     set keys for reading WTL data cards by ffread
      CALL FFKEY('DEWT', DEWT  ,NSLWT,'MIXED')           	
      CALL FFKEY('ZAWT' ,ZAWT  ,NSLWT,'REAL')           	
      CALL FFKEY('DLWT' ,DLWT  ,NSLWT,'REAL')           	
      CALL FFKEY('DIWT' ,DLWAWT,   14,'REAL')
      CALL FFKEY('ANWT' ,ANGWT,     1,'REAL')
      CALL FFKEY('ROWT' ,ROTZWT,NSLWT,'REAL')  
      CALL FFKEY('EFWT' ,EFFWT,     1,'REAL')
      CALL FFKEY('ACWT' ,SIGWT,     4,'REAL')
      CALL FFKEY('PIWT' ,PITWT,     4,'REAL')
      CALL FFKEY('DMWT' ,DIMXWT,    4,'REAL')
      CALL FFKEY('XOWT' ,XOWT  ,NSLWT,'REAL')
      CALL FFKEY('YOWT' ,YOWT  ,NSLWT,'REAL')
      CALL FFKEY('XIWT' ,XIWT  ,NSLWT,'REAL')
      CALL FFKEY('XLWT' ,XLWT  ,NSLWT*NSCWT,'REAL')           	
      CALL FFKEY('XRWT' ,XRWT  ,NSLWT*NSCWT,'REAL')           	
      CALL FFKEY('YLWT' ,YLWT  ,NSLWT*NSCWT,'REAL')           	
      CALL FFKEY('YRWT' ,YRWT  ,NSLWT*NSCWT,'REAL')           	
      CALL FFKEY('NPWT' ,NPLWT ,NSLWT,'INTE')
      CALL FFKEY('NSWT' ,NSECWT,NSLWT,'INTE')
      CALL FFKEY('NWWT' ,NWIRWT,NSLWT*NSCWT,'INTE')            	
      CALL FFKEY('IRWT' ,IROWT, NSLWT,'INTE')

C     Read in of data cards
      CALL FFSET('LINP',LREAD)
      CALL FFSET('LOUT',LLOGF)
      CALL FFGO
      CALL IOCLOS(LREAD)


 999  RETURN
      END

************************   END    WTLDAT    *****************************




