
>NAME LIKUIP2

>Menu /List2
>Guidance
Print information stored in detector banks.

>Command HITB
>Parameters
+
HITB1   'Id of first hit' I D=0
HITB2   'Id of last  hit' I D=0
GEDE    'Associated plane' I D=0
GESL    'Associated superlayer' I D=0
MIMP    'Associated mimp' I D=0
MTRA    'Associated MC track' I D=0
RTRA    'Associated reconstructed track' I D=0
RHIT    'Associated reconstructed hit' I D=0
CHOPT 'Options' C
>Guidance
Print hit information (from HITB table).
When the number of an MC, mimp, reconstructed track, reconstructed hit,
plane or superlayer object is specified,
only hits associated with this object will be printed.

Options:

  no options defined yet

>Action PRHITS

>Command GEDE
>Parameters
+
GEDE1 'Id of first plane number' I D=0
GEDE2 'Id of last  plane number' I D=0
GESL  'Superlayer' I D=0
MIMP  'Associated mimp' I D=0
HITB  'Associated hit' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print plane information (from GEDE table).
When the number of an associated superlayer, mimp, hit object is
specified, only planes associated with this object will be printed.

Options: if no options are given, lengthy geometry information is
         suppressed. This information can be retrieved via options

    -B : print border information
    -G : print GEPT entries
    -R : print rotation matrix & stereo angles
    -W : print wire geometry information

>Action PRPLNS

>Command GWAL
>Parameters
+
GWAL1 'Id of first wall' I D=0
GWAL2 'Id of last  wall' I D=0
GESL  'Superlayer' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print wall information (from GWAL table).

>Action PRGWAL

>Command GESL
>Parameters
+
GESL1 'Id of first superlayer' I D=0
GESL2 'Id of last  superlayer' I D=0
>Guidance
Print superlayer information on superlayer range.

>Action PRSUPL

>Command MTRA
>Parameters
+
ID1 'Id of first MC particle' I D=0
ID2 'Id of last  MC particle' I D=0
>Guidance
Print MC particles

>Action PRMC

>Command MVER
>Parameters
+
ID1 'Id of first MC vertex' I D=0
ID2 'Id of last  MC vertex' I D=0
>Guidance
Print MC vertices

>Action PRVER

>Command RTRA
>Parameters
+
ID1   'Id of first track' I D=0
ID2   'Id of last  track' I D=0
MTRA  'Associated MC particle' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print reconstructed tracks

Options:
  -C : in addition print covariance matrix from track fit
  -M : show matching information from closest mimp

>Action PRTRAC


>Command RSEG
>Parameters
+
ID1   'Id of first reconstructed segment' I D=0
ID2   'Id of last  reconstructed segment' I D=0
MTRA  'Associated MC particle' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print reconstructed tracks

Options:
  -L : show track parameters of last instead of first point
  -C : in addition print covariance matrix from track fit

>Action PRRSEG



>Command RPNT
>Parameters
+
ID1   'Id of first reconstructed point' I D=0
ID2   'Id of last  reconstructed point' I D=0
RTRA  'Associated reconstructed track' I D=0
RSEG  'Associated reconstructed segment' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print reconstructed tracks

Options:
  -C : in addition print covariance matrix from track fit

>Action PRRPNT





>Command RHIT
>Parameters
+
RHIT1 'Id of first reconstructed hit' I D=0
RHIT2 'Id of last  reconstructed hit' I D=0
RTRA  'Associated reconstructed track' I D=0
RSEG  'Associated reconstructed segment' I D=0
HITB  'Associated hit (from hitb bank)' I D=0
GEDE  'Associated plane' I D=0
GESL  'Associated superlayer' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print reconstructed hit coordinates

When the number of a reconstructed track, hit, plane or superlayer
object is specified, only reconstructed hits associated with this object
will be printed.
Options:

  no options defined yet

>Action PRHFIT

>Command MIMP
>Parameters
+
MIMP1 'Id of first mimp' I D=0
MIMP2 'Id of last  mimp' I D=0
MTRA  'Associated MC particle' I D=0
RTRA  'Associated reconstructed track' I D=0
HITB  'Associated hit' I D=0
GEDE  'Associated plane' I D=0
GESL  'Associated Superlayer' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print MIMP (Monte Carlo impact point) information on detector range.
When the number of an MC, hit, plane or superlayer object is specified,
only mimps associated with this object will be printed.
Options:

  no options defined yet

>Action PRMIMP

>Command TOPP
>Parameters
+
TOPP1 'Id of first particle' I D=0
TOPP2 'Id of last  particle' I D=0
>Guidance
Print TOPP (Table of particles) entries.
>Action PRTOPP

>Command DIGB
>Parameters
+
DIGB1 'Id of first DIGB digit' I D=0
DIGB2 'Id of last  DIGB digit' I D=0
>Guidance
Print rows from DIGB digit table
>Action PRDIGB

>Command HITC
>Parameters
+
HITC1 'Id of first HITC digit' I D=0
HITC2 'Id of last  HITC digit' I D=0
GCAL 'Id of ECAL block number' I D=0
>Guidance
Print rows from HITC (ecal hit) table
>Action PRHITC

>Command MCAL
>Parameters
+
MCAL1 'Id of first MCAL digit' I D=0
MCAL2 'Id of last  MCAL digit' I D=0
GCAL 'Id of ECAL block number' I D=0
>Guidance
Print rows from MCAL (ecal hit) table
>Action PRMCAL

>Command GCAL
>Parameters
+
GCAL1 'Id of first GCAL object' I D=0
GCAL2 'Id of last  GCAL object' I D=0
CHOPT 'Options' C D=' '
>Guidance
Print rows from GCAL (ecal blocks) table

Options: if no options are given, lengthy geometry information is
         suppressed. This information can be retrieved via options

    -B : print border information
    -G : print GEPC entries

>Action PRGCAL

>Command CHAIN
>Parameters
MTRA  'Id of MC particle' I D=0
>Guidance
Print decay chain for MC particle
>Action PRCHAIN
