*-- Author :    Rainer Mankel   21/12/93

      subroutine dihead()

*     **** plot a header text box on the current picture
      implicit none
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/EVHD.fi"
#include "pris/zgraf.fi"
#include "pris/zframe.fi"

      real hdat(2), htim(2), x0, y0, xd, xh
      real x1box, x2box, y1box, y2box
      integer icurrent, nprint, npvert, npmult
      real xwi1, xwi2, ywi1, ywi2, xmin, xmax, ymin, ymax
      real x(2), y(2)
      character*80 cinput, cgeo, chbook, cmeta, cc(14)
      logical lopened
      data icurrent /0/
      save icurrent
#include "arte/Arte.ff"
#include "auto/EVHD.ff"

      call iselnt(nt_pictzg)

      xmin = 0.
      xmax = 100.
      ymin = 100.*c
      ymax = 100.*(1.-c)
	
      xwi1 = xmin + 6.
      xwi2 = xmax
      ywi1 = ymin + 6.
**      ywi2 = ymax -10.
      ywi2 = ymax - 8.

*     **** collect information

*     **** get date and time
      call datimh(hdat,htim)

*     **** get input dataset name
      chbook = ' '
      inquire(unit=lhist   ,name=chbook)
      cgeo = ' '
      inquire(unit=lgeoi   ,name=cgeo)
      cinput=' '
      inquire(unit=levin(1),name=cinput)
      cmeta = ' '
      inquire(unit=lpris   ,name=cmeta)

*     **** number of current picture
      icurrent = icurrent + 1

*     **** event statistics
      call tuevst(npvert,npmult)

      if (chbook.ne.' ') then
         write(cc(1),'((a),a60)') ' hbook= ',chbook
      else
         cc(1) = ' '
      endif
      if (cgeo.ne.' ') then
         write(cc(2),'((a),a60)') ' geo= ',cgeo
      else
         cc(2) = ' '
      endif
      if (cinput.ne.' ') then
         write(cc(3),'((a),a60)') ' evt inp= ',cinput
      else
         cc(3) = ' '
      endif
**      write(cc(4),'((a),a60)') ' PostScript= ',cmeta
      if (jevhd.gt.0) then
         write(cc(4),'((a),i6,i5,i3)') ' EvtRunExp = ',ievhd_evt(1),
     +        ievhd_run(1),ievhd_exp(1)
      else
         cc(4) = ' '
      endif
      write(cc(5),'((a),2a4)') ' date= ',hdat
      write(cc(6),'((a),2a4)') ' time= ',htim
      write(cc(7),'((a),i8)')  ' event= ',nevents
      write(cc(8),'((a),i8)')  ' picture= ',icurrent
      if (npvert.gt.0.or.npmult.gt.0) then
         write(cc(9),'((a),i2,''/'',i4)') ' nvert/mult= ',npvert, npmult
      else
         cc(9) = ' '
      endif
      write(cc(10),'((a),a20)') ' inst=', instname
      write(cc(11),'((a),a20)') ' host=', hostname
      write(cc(12),'((a),f10.4)') ' arte vs=', artevers
      write(cc(13),'((a),f10.4)') ' geom vs=', geomvers
      write(cc(14),'((a))') ' prism 4.11/04b'

*     **** plot on current picture

*     **** determine world coordinates of visible frame objects
      x0 = xmin + 60.
      y0 = ymin + 60.
      xh = 1.0
      xd = 0.8

      x1box = xmin
      x2box = xmax
      y1box = ywi2
      y2box = ymax

      nprint = 4

*     **** background color box
      call igset('BORD',0.)
      call igset('FACI',0.)
      call igset('FAIS',1.)
      call igbox(x1box,x2box,y1box,y2box)

*     **** draw the separation between header and plot
      x(1) = xmin
      y(1) = ywi2
      x(2) = xwi2
      y(2) = ywi2
      call ipl(2,x,y)

      call igset('PLCI',1.)
      call istxfp(0,2)
      call igset('TXAL',3.)
      call ischh(5.)
      call igset('PASS',3.)
      call igset('TXCI',cotxtzg)
      call igset('TXFP',-20.)
**      call itx(xmin+1.,0.5*(ywi2+ymax),'HERA-B')
      call itx(xmin+1.,0.5*(ywi2+ymax)+0.3,'prism')
      call igset('PASS',1.)

**      call istxfp(0,2)
      call igset('TXFP',-20.)
      call istxal(0,0)
      call ischh(xh)
      y0 = y0 - 2. * xd

      call itx(xmin+30.,ymax-2.*xd,cc(14))
      call itx(xmin+45.,ymax-2.*xd,cc(3))

      call itx(xmin+30.,ymax-4.*xd,cc(11))
      call itx(xmin+45.,ymax-4.*xd,cc(5))
      call itx(xmin+60.,ymax-4.*xd,cc(2))

      call itx(xmin+30.,ymax-6.*xd,cc(12))
      call itx(xmin+45.,ymax-6.*xd,cc(6))
      call itx(xmin+60.,ymax-6.*xd,cc(4))

      call itx(xmin+30.,ymax-8.*xd,cc(8))
      call itx(xmin+45.,ymax-8.*xd,cc(7))
      call itx(xmin+60.,ymax-8.*xd,cc(9))

**      call itx(xmin+30.,ymax-10.*xd,cc(13))
**      call itx(xmin+45.,ymax-10.*xd,cc(8))
**      call itx(xmin+60.,ymax-10.*xd,cc(9))

      call igset('FACI',0.)
      call igset('FAIS',0.)
      call igset('FASI',0.)
      call isfaci(0)
      call isfais(0)
      call igset('LWID',8.)
      call igbox(x1box,x2box,y1box,y2box)
      call igset('LWID',1.)


      end


**********************************************************
* Versions:
*
* 4.11/04 - TRD-related changes (didraw,digett,dihit,dikscope,
*           diplab,pkhit,pkpick), (thanks to V. Egorytchev,)
*           angle view extensions (dighit,dihit),
*           hard stop in tumclo removed
* 4.11/03 - di1rtra switched to ditraj, RVER and RCCL 
*           information added in di1rtra
* 4.11/02 - markers introduced in ditraj,
*           di1rseg switched to ditraj, ignores kill-flagged segments
*           wobbles bug fixed in di1rtra
* 4.11/01 - di1mc restructured (ditraj)
*           bug in neutrals display fixed
* 4.11/00 - RICH event display (thanks to D. Duijmic)
*           ECAL cluster display (thanks to A. Somov)
*           RSEG/ECAL display on angular view
* 4.10/01 - adaption to Arte-02
*           introduction of frame stack
*           bug in dirv.F fixed
*           Arte table references streamlined
* 4.09/06 - RICH mimp's removed in di1mc.F
* 4.09/05a - option b in display/frame
* 4.09/05 - only tracker mimps in /zmh/, di1mc uses relation
* 4.09/04 - new include file reference scheme
* 4.09/03 - inclusion of A. Lanyovs shp modifications
*
********************************************************** 

