*-- Author :    Rainer Mankel   10/08/93

      subroutine turemc(itrst,imcass,fracmc)

      implicit none
#include "arte/Arte.fi"

      integer maxid, itrst, imcass, maxmc
      parameter (maxid=100,maxmc=20000)
      integer icount(maxmc), ind_mc(maxmc)
      integer nhit, iihit, nsort, imc, nmxass, hf
      integer iii
      real fracmc
      parameter (nmxass=40)
      integer jmcass, nmcass, mcass(nmxass)
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RHIT.fi"
#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/RHIT.ff"

*     **** calculate for reconstructed track ITRST in /zt/ the
*     **** associated MC particle
*     **** if itrst<=0: take track candidate in /zr/ instead
*     **** same as diremc, but only for 1 track

       do iii=1,maxmc
        icount(iii) = 0
       enddo

*      **** loop over hits used for track
       nhit = 0

       do 10 hf=1,iq(jrhit+2)
	if (irhit_rtra(hf).ne.itrst) go to 10
	nhit = nhit + 1

        iihit = orhit_hitb(hf)

*       **** locate MC particles associated with this hit
        call tumclo(iihit,nmxass,nmcass,mcass)

*       **** loop over associated MC particles
        do jmcass=1,nmcass
         imc = mcass(jmcass)
         if (imc.lt.1.or.imc.gt.iq(jmtra+2)) then
          print *,' () turemc: invalid imc=', imc
          stop 'turemc'
         endif
         if (imc.le.maxmc) then
          icount(imc) = icount(imc) + 1
         else
          print *,' () turemc: overflowing imc=', imc
         endif
        enddo

 10    continue

*      **** sort according to number of occurences
       nsort = maxmc

       call sortzv(icount,ind_mc,nsort,-1,1,0)

       imcass = ind_mc(1)
       fracmc = float( icount( imcass ) ) / float( nhit )

       end







