// 
//  Author:  Rainer Mankel                     Created:  02-Oct-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
//

// Fortran callable interface to rangerSeg2track
 
#include "arte/ArteAll.hh"
#include "auto/MTMT.hh"
#include "rang/seg2track.hh"

extern "C" {
  int rgseg2t_(const int& rs) {
    if (ArtePointer<RSEG>::nrow() <= 0) return 0;
    ArtePointer<RSEG> rseg(rs);
    ArtePointer<RTRA> rtra = rangerSeg2track(rseg);
    return rtra.index();
  }
}

