*CMZ :  4.02/00 19/07/96  13.56.48  by  Rainer Mankel
*CMZ :  4.01/00 03/10/95  15.00.39  by  Rainer Mankel
*-- Author :    Rainer Mankel   02/10/95

      subroutine tfmtch(mc,rc,OK)

      implicit none
#include "arte/Arte.fi"

#include "pris/zmh.fi"


#include "rang/zf.fi"
#include "rang/zfmode.fi"

      integer nmx
      parameter (nmx=10)
      integer mc, rc, OK, nhit, jaux, hf, mimp, nnmimp, ih, jmc, iih,
     +      hit_array(nmx), nso, iso, iihitf, nhits
      real zlowrc, zlowmc
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/MIMP.fi"
#include "auto/RHIT.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/MIMP.ff"
#include "auto/RHIT.ff"

*     **** loop over mimps
      zlowrc = 9999.

*     **** loop over hits used for track
      nhit = 0
      do 10 hf=1,nrhit()
       if (irhit_rtra(hf).ne.rc) go to 10

       nhit = nhit + 1
       if (fhitb_z(orhit_hitb(hf)).lt.zlowrc) zlowrc =
     +      fhitb_z(orhit_hitb(hf))
 10   continue
 11   continue

*     **** loop over mimps for MC particle
      zlowmc = 9999.
      nso = nmimmh(mc)
      do 30 iso=nso,1,-1
       mimp = imimmh( istamh(mc) + iso )
       if (igede_cmp(imimp_gede(mimp)).eq.1) go to 30 ! no Si/magnet
*      **** get hits associated with mimp
       call tumimph(mimp,nmx,hit_array,nhits)
*      **** loop over associated hits
       do iih=1,nhits
        ih = hit_array(iih)
        if (ih.le.0.or.ih.gt.iq(jhitb+2)) then
         print *,' () tfidea: invalid ih=',ih,' at iih,mimp=',iih,mimp
         stop 'tfidea'
        endif

*       **** no merged points
        call tuhmimp(ih,jmc,mimp,nnmimp)
        if (nnmimp.gt.1) go to 30

*       **** check z
        if (fhitb_z(ih).lt.200.) go to 30
        if (fhitb_z(ih).lt.zlowmc) zlowmc = fhitb_z(ih)
       enddo
 30   continue

**      print *,' tfmtch: mc=', mc, 'rc=', rc,' zlowmc=', zlowmc,
**     +        ' zlowrc=', zlowrc
      if (zlowrc.gt.(zlowmc+100.)) then
**       print *,' -------------------------> discarded '
       OK = -1
      else
**       print *,' -------------------------> accepted '
       OK = +1
      endif

      end
