
// ********************************************************************
//
// source:    usevnt.C
//
// type:      source code template
//
// created:   22 Oct 98
// modified:   
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// ********************************************************************

// includes
#include "arte/Arte.hh"

//#include "auto/EV.hh"
//#include "auto/GEO.hh"

extern "C" {
void hgevnt_();
void dgevnt_();
void rcevnt_();
}

//
// function
//
void
usevnt_()
{
  // ******************************************************************
  
  // Step 1: GEANT detector simulation.
  //         No action if event is measured and not generated.
  //         Action only if the command GEANT is given.
  
  hgevnt_();
  
  // ******************************************************************

  // Step 2: Detector digitization.
  //         No action if event is measured and not generateD

  dgevnt_();
  
  // ******************************************************************
  
  // Step 3: Event reconstruction.
  
  // rcevnt_();

  // ******************************************************************

  // Step 4: Event analysis.



}
