*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTDEL(iv,flag)
c
c       input:    iv          =  vertex index         Int
c
c       output:   flag        <0 if fail              Int
c
c       action:   deletes vertex iv
c
c-------------------------------------------------------------
c
      subroutine  VTDEL( iv, flag )

      implicit none

      integer iv

      integer flag

      integer i, j, k, n

#include "vt/vtdat.fi"

      if ( iv .gt. nvtmax  )   goto 999
      if ( .not. vtset(iv) )   goto 999

      do  i = 1, ntrtot
        j = jv(iv,i)
        jv(iv,i) = 0
        if ( j .gt. 0 ) then
          n = nv(i)
          nv(i) = n - 1
          do  k = j+1, n
            jv(kv(i,k),i) = jv(kv(i,k),i) - 1
            kv(i,k-1) = kv(i,k)
          enddo
          kv(i,n) = 0
        endif
      enddo

      n = ntr(iv)
      do  k = 1, n
        ktr(iv,k) = 0
      enddo
      ntr(iv) = 0

      fit(iv)    = 0
      smooth(iv) = 0
      fitm(iv)   = 0
      dist(iv)   = 0
      vtset(iv) = .false.
      nvt = nvt - 1
      flag = 0
      return

999   continue
      flag = -1
      return
      end
