#ifndef __OTR_EFFICIENCYH1F_HH__
#define __OTR_EFFICIENCYH1F_HH__

#ifndef ROOT_H1F
#include <TH1.h>
#endif

/** This is the EfficiencyGraph class. An efficiency graph used to contain EfficiencyBin's to mean and error calculations based on binominal statistics. The implementation is of EfficiencyBin is moved to this class and EfficiencyBin is now obsolete **/

class OTrEfficiencyH1F : public TH1F
{
private:
  float* fNfound; // 
  float* fNall;
public:
  OTrEfficiencyH1F(const Text_t *const name, Text_t* title, 
		   Int_t nbinsx, Axis_t xlow, const Axis_t xup);
  virtual ~OTrEfficiencyH1F() ;
  virtual void Fill(Axis_t x, bool found, Stat_t w=1);
  virtual void Draw(Option_t* option="");
  virtual void Paint(Option_t *option="") ;
  virtual void Reset() ;
  virtual void Calculate() ;
  virtual void PrintEmptyBins() ;
  virtual void Print() ;
  ClassDef(OTrEfficiencyH1F,0) // The Outer Tracker class for describing efficiencies
} ;

#endif
